// Class: ColMajorGridIterator
//
// Author: Alyce Brady
//
// License Information:
//   This class is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation.
//
//   This class is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

import edu.kzoo.grid.BoundedGrid;
import edu.kzoo.grid.Location;

/**
 *  Grid Iterator Lab:<br>
 *
 *    A ColMajorGridIterator object provides an iterator that
 *    steps through the locations of a BoundedGrid object in
 *    column-major order.  It iterates through the locations and
 *    processes the columns of the grid, from 0 to C - 1,
 *    where C is the number of columns in the grid.  As
 *    part of processing each column, it traverses through the
 *    rows of that column, from 0 to R - 1, where R is the
 *    number of rows in the grid.
 *
 *  @author Alyce Brady
 *  @version 24 March 2004
 *  @see edu.kzoo.grid.Grid
 *  @see edu.kzoo.grid.Location
 **/
public class ColMajorGridIterator extends GridIterator
{
    /** Constructs an iterator object that steps through a
     *  grid.
     *  @param grid     grid to iterate through
     **/
    public ColMajorGridIterator(BoundedGrid grid)
    {
        super(grid);
    }

    /** Helper Method: Finds next location for iterator.
     *  (Algorithm not implemented yet -- does not advance iterator.)
     **/
    protected Location findNextLocation()
    {
        // For now, just return the current "next" location without
        // advancing the iterator.
        System.out.println("The iterator for column-major traversals " +
                           "has not been implemented yet.");
        return nextLocation();
    }

}
